#ifndef __STRINGBST_H
#define __STRINGBST_H

using namespace std;
#include <string>
#include <vector>

struct SBSTNode{
    SBSTNode* left;
    SBSTNode* right;
    SBSTNode* parent;
    string data;
    vector<unsigned int>* locations;
};

class stringBST{

public:
    stringBST(bool inLoc);
    ~stringBST();
    bool insert(string inS);
    bool insert(string inS, int inLoc);
    bool search(string inS);
    bool remove(string inS);
    void print(){print(true);}
    void print(bool inNL);
 
private:

    // Private functions
    SBSTNode* find(string inS);
    SBSTNode* findp(string inS);
    bool lessThan(string inSL, string inSR);
    void del(SBSTNode* inNode);
    void prHelper(SBSTNode* inN, bool inNL);
    void leftRotate(SBSTNode* inN);
    void rightRotate(SBSTNode* inN);
    void splay(SBSTNode* inN);

    // Private vars
    SBSTNode* root; // Yeah. It's the root of the tree.
    unsigned int size; // How many nodes in the tree (non-duplicates)?
    bool loc; // Storing locations (multiple entries) ?

};
#endif
